#include <pic.h>
//pic16f628a
/*   */
 

__CONFIG (INTIO & UNPROTECT & LVPDIS & BOREN & MCLRDIS & PWRTEN & WDTDIS);
__EEPROM_DATA(0,0,0,0, 0,0,0,0);
__EEPROM_DATA(0,0,0,0, 0,0,0,0);

#define BITNUM(adr,bit)((unsigned)(&adr)*8+(bit)) // -.
#define ON 1                                      // -  .
#define OFF 0                                     // -  .
  
static bit DB0  @ BITNUM(PORTB,0); //
static bit DB1  @ BITNUM(PORTB,1); //
static bit DB2  @ BITNUM(PORTB,2);
static bit DB3  @ BITNUM(PORTB,3);
static bit DB4  @ BITNUM(PORTB,4); //
static bit DB5  @ BITNUM(PORTB,5); //
static bit DB6  @ BITNUM(PORTB,6); //
static bit DB7  @ BITNUM(PORTB,7); //

bit FLAG_0;         // .
bit FLAG_1;         // .
bit FLAG_2;         // .
bit FLAG_3;         // .
bit FLAG_4;         // .

#define OTKR		RA1
#define ZAKR		RA0
#define SVET		RA6
#define seg7__7		RA7     // .
#define seg7__2		RA2
#define seg7__3		RA3
#define seg7__4		RA4     // .

volatile unsigned int v1[5]; // . v[4] -   
    unsigned long int v, BUF, VVOD, vk, vr, vsr;
    unsigned char i, F, ak;
    unsigned int  fz;

   void low_init()
 {
   CMCON=0x07;    //  

   TRISA=0b00000000; 	
   PORTA=0x00;

   TRISB=0x00;    //	
   PORTB=0x00;
   RBPU = 0;  //  R (0-, 1-)
 FLAG_0=0;                // .
 FLAG_1=0;                //
 FLAG_2=0;                //
 FLAG_3=0;                //
 FLAG_4=0;                // 
   fz=0;
 SVET=0;
 ZAKR=0;
 OTKR=0;
  vsr=0;

   //

  for (int index = 3; index >= 0; index--)
	{
		vsr += EEPROM_READ(index);
		if (index != 0) vsr <<= 8;
	};

 }

   // unsigned int 0  65535
  // delayt   p
   void delayt(unsigned long int p)
 {
   unsigned long int J;
   unsigned char K;
   for(J=0;J<p;J++)
   for(K=0;K<20;K++)
 {
   asm("NOP");
 }
 }

   void delay(unsigned int p)
 {
   unsigned int J;
   for(J=0;J<p;J++)
 {
   asm("NOP");
 }
 }

const unsigned char Ind7_Led[]= { //  
 //   gb cdefa
	0b11000000,	 // "0" 
	0b11111001,	 // "1"
	0b10100100,	 // "2"
	0b10110000,	 // "3"
	0b10011001,	 // "4"
	0b10010010,	 // "5"
	0b10000010,	 // "6"
	0b11111000,	 // "7"
	0b10000000,	 // "8"
	0b10010000,	 // "9"
	0b11111111}; // 
//********************************************************************************


  void OPROSKL(void) {

   TRISB=0b11111000;    //  1111  1000 F8 

      PORTB=0b11111111;


 //************************************************************************* 
  DB0=0;       // RB0
  DB1=1;
  DB2=1;

  if(DB3==0) {  
   VVOD=3;
  FLAG_0=ON;     // ON=1.
   return;
    }  
    else
      {
  FLAG_0=OFF;     // OFF=0.
       }

  if(DB4==0) {  
   VVOD=6; 
  FLAG_0=ON;     // ON=1.
   return;
  }  
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }

  if(DB5==0) {  
   VVOD=9;  
  FLAG_0=ON;     // ON=1.
   return;
  } 
    else
      {
  FLAG_0=OFF;     // OFF=0.

       } 

    if(DB6==0) {    // 
   vr=0;  
  FLAG_0=ON;     // ON=1.
   return;

  }
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }
//*************************************************************************
   DB0=1;  
   DB1=0;   //  RB1
   DB2=1;

  if(DB3==0) {  
   VVOD=2;
   FLAG_0=ON;     // ON=1.
   return;
  }  
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }

  if(DB4==0) {  
   VVOD=5;  
    FLAG_0=ON;     // ON=1.
   return;
  }  
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }
   
   
   
  if(DB5==0) {  
   VVOD=8;  
    FLAG_0=ON;     // ON=1.
   return;
  }  
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }

  if(DB6==0) {  
   VVOD=0;  
    FLAG_0=ON;     // ON=1.
   return;
  }  
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }
 //*************************************************************************
   DB0=1;
   DB1=1; 
   DB2=0;        //  RB2

  if(DB3==0) {  
   VVOD=1;  
    FLAG_0=ON;     // ON=1.
   return;
  }  
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }

  if(DB4==0) {  
   VVOD=4;  
    FLAG_0=ON;     // ON=1.
   return;
  }  
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }

  if(DB5==0) {  
   VVOD=7;  
    FLAG_0=ON;     // ON=1.
   return;
  }  
    else
      {
  FLAG_0=OFF;     // OFF=0.

       }
//******************************
//******************************
  if(DB6==0) {      //  

  if(vsr==vr) { 
      SVET = 1;
      OTKR = 1;
      delay(65455);
      delay(65455);
      OTKR = 0;
      F = 0;
    }
    else
      {
//***********
  if(SVET==1) { 
      ZAKR = 1;
      delay(65455);
      delay(65455);
      ZAKR = 0;
      SVET = 0;
      F = 0;
       }

    while(FLAG_2==0){
     F++;
   FLAG_2 = 1;
    while(F==4){
     // delayt(225444);   //1  
      delayt(6763320);  //30  
     
      F = 0;
           }
           }
//***********
       }
   return;
  }  
   FLAG_2 = 0;
          
     //******************************
    if(DB7==0) {
    if(SVET==1) {
       fz++;
   if(fz==64)  // 
    { //
      vsr=vr;

         //

	  int shift = 0;

	  for (int index = 0; index < 4; index++) {
		  EEPROM_WRITE(index, vsr >> shift & 0xFF);
		  shift += 8;
	  }

      fz=0;
      SVET = 0;
    }
    }
    }
   DB2=1;

  } 


 //******************************

 //******************************
    void OPROS(void) {
//********************************************************************************
      if(FLAG_0==1) //
      {
          delay(20); //
    while(FLAG_1==1){ //
     if(vr==0) {
     vr=VVOD;

     FLAG_1=OFF;     // OFF=0 .
         }
    else
        { 
     BUF=VVOD; 
     vr=BUF + (vk * 10);

     FLAG_1=OFF;     // OFF=0 .
        }
      }  //while 1

      }  //if 0
    else
        {
      FLAG_1=ON;     // ON=1.
        }
//**************************************************
     vk=vr;
     v=vr;
     for (i=4; i>=1; i--){ //   - 
     v1[i] = v % 10;
     v = v / 10;
       }

     for (i=4; i>=1; i--){ //    
     v1[i] = Ind7_Led[v1[i]];   //1- . 4- .
       }

   TRISB=0x00;

    }  
 //************************************************************************* 



void main ()   //  
{ //  
   low_init(); //    

    // while(1)  
while(1)  //
{ //   

          OPROSKL();   //

          OPROS();   // 


		PORTB = v1[4]; //  
		seg7__4 = 1; //  .
                delay(25); // 
		seg7__4 = 0; //  .

		PORTB = v1[3]; //  
		seg7__3 = 1; //  .
                delay(25); // 
		seg7__3 = 0; //  .

		PORTB = v1[2]; //  
		seg7__2 = 1; //  .
                delay(25); // 
		seg7__2 = 0; //  .

		PORTB = v1[1]; //  
		seg7__7 = 1; //  .
                delay(25); // 
		seg7__7 = 0; //  .

} //   

} //  